<?php

$productObj = new products();

class Products
{
  var $mDb;
  var $mConfig;

  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
  }

  function convert_object_to_array($data)
  {
    if (is_object($data)) {
      $data = get_object_vars($data);
    }

    if (is_array($data)) {
      return array_map(__METHOD__, $data);
    } else {
      // echo "test"; die();
      return $data;
    }
  }
  function fetchALL($lang)
  {
    $stmt = "SELECT p.id, pl.description, pl.name, pl.lang_code,p.sort,p.created_at FROM products p RIGHT JOIN `products_langs` pl ON p.id = pl.product_id AND pl.lang_code =  '{$lang}'";

    $res = $this->mDb->getAll($stmt);
    return $res;
  }

  function addProduct($params, $price, $sort, $user_id)
  {

    $categories = json_decode($params['categories']);
    $productLangObj = json_decode($params['langs']);
    $productImgObj = $params['images'];
    $newproductLangObj = $this->convert_object_to_array($productLangObj);

    $stmt = "INSERT INTO `products` (`price`, `sort`, `user_id`) VALUES ";
    $stmt .= "('{$price}', '{$sort}', '{$user_id}')";
    $this->mDb->query($stmt);



    $last_product_id = $this->mDb->getLastInsertId();


    if ($last_product_id) {
      for ($i = 0; $i < count($categories); $i++) {
        $stmt = "INSERT INTO `products_categories` (`category_id`, `product_id`) VALUES ";
        $stmt .= "('{$categories[$i]}', '{$last_product_id}')";
        $res = $this->mDb->query($stmt);
      }
    }
    foreach ($newproductLangObj as $key => $value) {
      $stmt = "INSERT INTO `products_langs`(`product_id`, `lang_code`, `name`, `description`) ";
      $stmt .= " VALUES ('{$last_product_id}', '{$value['lang_code']}', '{$value['name']}', '{$value['description']}')";
      $res = $this->mDb->query($stmt);
    }
    if (isset($params['images'])) {
      $productImgObj = $params['images'];
      $newproductImgObj = $this->convert_object_to_array($productImgObj);

      foreach ($newproductImgObj as $image) {
        $stmt = "INSERT INTO `products_images`(`product_id`, `image`) ";
        $stmt .= " VALUES ('{$last_product_id}', '{$image}')";
        $res = $this->mDb->query($stmt);
      }
    }


    $sql = "SELECT * FROM products where id ='{$last_product_id}'";

    return $this->mDb->getAll($sql);
  }

  function editProduct($id, $params, $price, $sort)
  {
    $categories = json_decode($params['categories']);
    $productLangObj = json_decode($params['langs']);
    $newproductLangObj = $this->convert_object_to_array($productLangObj);
    $productImgObj = $params['images'];
    $sql = "SELECT `image` FROM `products_images` WHERE `product_id` = '{$id}'";
    $oldImages = $this->mDb->getAll($sql);
    
    if (count($oldImages)) {
      foreach ($oldImages as $oldImage) {
        $oldImagePath = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . $oldImage['image'];
        if (file_exists($oldImagePath)) {
          unlink($oldImagePath);
        }
      }
    }

    $sqll = "DELETE FROM `products_images` WHERE `product_id` = '{$id}'";
    $this->mDb->query($sqll);

    foreach ($productImgObj as $image) {
      $stmt = "INSERT INTO `products_images` (`product_id`,`image`) VALUES ('{$id}','{$image}')";
      $res = $this->mDb->query($stmt);
    }
    

    // Update the main product table
    $stmt = "UPDATE `products` SET  `price` = '{$price}',  `sort` = '{$sort}' WHERE `id` = '{$id}'";
    $this->mDb->query($stmt);


    // Update the product_langs table
    foreach ($newproductLangObj as $key => $value) {
      $value['description'] = str_replace("'", "\'", $value['description']);
      $stmt = "UPDATE `products_langs` SET";
      $stmt .= " `name`='{$value['name']}', ";
      $stmt .= " `description`='{$value['description']}' ";
      $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `product_id` = '{$id}'";

      $res = $this->mDb->query($stmt);
    }

    // Update the products_categories table
    // First, delete existing associations for the product_id
    $stmtDelete = "DELETE FROM `products_categories` WHERE `product_id` = '{$id}'";
    $this->mDb->query($stmtDelete);

    // Insert new associations for the product_id and categories
    foreach ($categories as $category) {
      $stmtInsert = "INSERT INTO `products_categories` (`product_id`, `category_id`) VALUES ('{$id}', '{$category}')";
      $this->mDb->query($stmtInsert);
    }


    // Return the updated category data
    $sql = "SELECT * FROM `products` WHERE `id` = '{$id}'";
    return $this->mDb->getRow($sql);
  }
  function deleteProduct($id)
  {
    if ($id) {
      $product_ids = '(' . implode(',', $id) . ')';

      $sqll = "DELETE FROM `products_langs` ";
      $sqll .= "WHERE `product_id` IN " . $product_ids;

      $this->mDb->query($sqll);

      $productsql = "DELETE FROM `products` ";
      $productsql .= "WHERE `id` IN ({$product_ids})";
    } else {
      throw new Exception('ID does not exist.');
    }
    return $this->mDb->query($productsql);
  }
}
