<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Content-Type: application/json');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');


require_once('init.php');

$requestMethod = $_SERVER['REQUEST_METHOD'];
if ($requestMethod == "GET" && isset($_GET["action"]) && $_GET["action"] == "getAll") {

  $prodList = $productObj->fetchALL($_GET["lang"]);

  if (is_array($prodList) && count($prodList) > 0) {
    $data['data'] = $prodList;
  } else {
    $data['data'] = [];
    $data['msg'] = "No Data";
  }
} elseif ($requestMethod == "POST" && isset($_GET["action"]) && $_GET["action"] == "insert") {

  // print_r(json_decode($_POST['categories']));
  $sort = $_POST['sort'];
  $user_id = $_POST['user_id'];
  $price = $_POST['price'];

  $temp = array();

  $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
  $maxsize = 1024 * 20; //kb
  // $uploadFolder = 'wethaq/api/uploads/banks';
  $uploadFolder = $Config['uploads_path'];

  $thumbsConfig = array(
    array(
      'name' => 'medium',
      'width' => '240',
      'hight' => '250'
    ),
    array(
      'name' => 'small',
      'width' => '80',
      'hight' => '80'
    ),
  );

  $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);


  $images = [];

  for ($i = 1; $i <= count($_FILES); $i++){
    // print_r($_FILES);
    if (isset($_FILES['image' . $i]) && isset($_FILES['image'.$i]['name']) && $_FILES['image' . $i]['name'] != '') {
    // die();
    // print_r($_FILES['image2']);
      //get file name
      $file['name'] = addslashes($_FILES['image'.$i]["name"]);
      // get file type
      $file['type'] = $_FILES['image'.$i]['type'];
      // get filesize in KB
      $file['size'] = $_FILES['image'.$i]['size'] / 1024;
      // get file tmp path
      $file['tmp'] = $_FILES['image'.$i]['tmp_name'];
      //get file ext [to get max uploades size]
      $file['ext'] = $upload->GetExt($_FILES['image'.$i]["name"]);
      //check if guest have selected file or not
      if ($file['name'] != '') {
        // Start Uploading File
        $upfile = $upload->Upload_File($file, $maxsize);
        //if uploagetCategoryByParentIDding successfully
        // echo $upfile;die();
        if ($upfile) {
          $temp = $upfile['newname'];
          //   // print_r ($temp[$key]);die();
        } else {
          $error = true;
          $showError[] = $upload->showErrors();
          $top_msg['error'][] = $showError[0][0];
          echo $showError[0][0];
          die();
        }
        // print_r($_FILES['image']);
        // die();
      } else {
        $temp = null;
      }
    }


    $_POST["images"][] = $temp;
  }

  // print_r($_POST["images"]);
  // die();
  $result = $productObj->addProduct($_POST, $user_id, $sort, $price);

  if ($result) {
    $data['msg'] = "Row inserted successfully.";
    $data['status'] = true;
    $data['data'] = $result;
  } else {
    $data['msg'] = "Error inserting row.";
    $data['status'] = false;
  }
  // echo json_encode($data);
} elseif ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_GET['action']) && $_GET['action'] == 'update') {
  $id = $_POST['id'];
  $sort = $_POST['sort'];
  $user_id = $_POST['user_id'];
  $price = $_POST['price'];
  $temp = array();

  $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
  $maxsize = 1024 * 20; //kb
  // $uploadFolder = 'wethaq/api/uploads/banks';
  $uploadFolder = $Config['uploads_path'];

  $thumbsConfig = array(
    array(
      'name' => 'medium',
      'width' => '240',
      'hight' => '250'
    ),
    array(
      'name' => 'small',
      'width' => '80',
      'hight' => '80'
    ),
  );

  $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);


  $images = [];

  for ($i = 1; $i <= count($_FILES); $i++) {
    // print_r($_FILES);
    if (isset($_FILES['image' . $i]) && isset($_FILES['image' . $i]['name']) && $_FILES['image' . $i]['name'] != '') {
      // die();
      // print_r($_FILES['image2']);
      //get file name
      $file['name'] = addslashes($_FILES['image' . $i]["name"]);
      // get file type
      $file['type'] = $_FILES['image' . $i]['type'];
      // get filesize in KB
      $file['size'] = $_FILES['image' . $i]['size'] / 1024;
      // get file tmp path
      $file['tmp'] = $_FILES['image' . $i]['tmp_name'];
      //get file ext [to get max uploades size]
      $file['ext'] = $upload->GetExt($_FILES['image' . $i]["name"]);
      //check if guest have selected file or not
      if ($file['name'] != '') {
        // Start Uploading File
        $upfile = $upload->Upload_File($file, $maxsize);
        //if uploagetCategoryByParentIDding successfully
        // echo $upfile;die();
        if ($upfile) {
          $temp = $upfile['newname'];
          //   // print_r ($temp[$key]);die();
        } else {
          $error = true;
          $showError[] = $upload->showErrors();
          $top_msg['error'][] = $showError[0][0];
          echo $showError[0][0];
          die();
        }
        // print_r($_FILES['image']);
        // die();
      } else {
        $temp = null;
      }
    }


    $_POST["images"][] = $temp;
  }


  $result = $productObj->editProduct($id, $_POST, $price, $sort);


  if ($result) {
    $data['msg'] = 'Row updated successfully.';
    $data['status'] = true;
    $data['data'] = $result;
  } else {
    $data['msg'] = 'Error updating row.';
    $data['status'] = false;
  }
} elseif ($requestMethod == "POST" && isset($_GET["action"]) && $_GET["action"] == "delete") {
  $json = file_get_contents('php://input');
  $data = json_decode($json, true);
  $id = $data['id'];
  // print_r(implode(',', $id));
  $productData = $productObj->deleteProduct($id);
  $Data     = $productData ? $productData : '';


  if ($productData) {
    $data['msg'] = " deleted successfully.";
    $data['status'] = $productData;
  } else {
    $data['msg'] = "Error deleted row.";
    $data['status'] = $productData;
  }
}

echo json_encode($data);
