<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Content-Type: application/json');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');


require_once('init.php');
// include('classes/class.categories.php');

$requestMethod = $_SERVER['REQUEST_METHOD'];
if ($requestMethod == "GET" && isset($_GET["action"]) && $_GET["action"] == "getAll") {

  $categList = $categoryObj->fetchALL($_GET["lang"]);

  if (is_array($categList) && count($categList) > 0) {
    $data['data'] = $categList;
    $data['msg'] = "OK";
  } else {
    $data['data'] = [];
    $data['msg'] = "No Data";
  }
} elseif ($requestMethod == "POST" && isset($_GET["action"]) && $_GET["action"] == "insert") {
  
  $sort = $_POST['sort'];
  $temp = array();

  $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
  $maxsize = 1024 * 20; //kb
  // $uploadFolder = 'wethaq/api/uploads/banks';
  $uploadFolder = $Config['uploads_path'];

  $thumbsConfig = array(
    array(
      'name' => 'medium',
      'width' => '240',
      'hight' => '250'
    ),
    array(
      'name' => 'small',
      'width' => '80',
      'hight' => '80'
    ),
  );

  $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);
  // print_r($_FILES);die();

  if (isset($_FILES['image']['name']) and $_FILES['image']['name'] != '') {
    // print_r($_FILES['image']);
    // die();
    //get file name
    $file['name'] = addslashes($_FILES['image']["name"]);
    // get file type
    $file['type'] = $_FILES['image']['type'];
    // get filesize in KB
    $file['size'] = $_FILES['image']['size'] / 1024;
    // get file tmp path
    $file['tmp'] = $_FILES['image']['tmp_name'];
    //get file ext [to get max uploades size]
    $file['ext'] = $upload->GetExt($_FILES['image']["name"]);
    //check if guest have selected file or not
    if ($file['name'] != '') {
      // Start Uploading File
      $upfile = $upload->Upload_File($file, $maxsize);
      //if uploagetCategoryByParentIDding successfully
      // echo $upfile;die();
      if ($upfile) {
        $temp['image'] = $upfile['newname'];
        //   // print_r ($temp[$key]);die();
      } else {
        $error = true;
        $showError[] = $upload->showErrors();
        $top_msg['error'][] = $showError[0][0];
        echo $showError[0][0];
        die();
      }
      // print_r($_FILES['image']);
      // die();
    } else {
      $temp = null;
    }


  }

  $result = $categoryObj->addCategory($_POST['langs'], $temp["image"], $sort);

  if ($result) {
    // $insertedData = $categoryObj->addCategory($result);
    $data['msg'] = "Row inserted successfully.";
    $data['status'] = true;
    $data['data'] = $result;
  } else {
    $data['msg'] = "Error inserting row.";
    $data['status'] = false;
  }
  
  
  

 
} elseif ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_GET['action']) && $_GET['action'] == 'update') {
  $id = $_POST['id'];
  $image = $_FILES['image'];
  $sort = $_POST['sort'];
  $temp = array();

  $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
  $maxsize = 1024 * 20; //kb
  // $uploadFolder = 'wethaq/api/uploads/banks';
  $uploadFolder = $Config['uploads_path'];

  $thumbsConfig = array(
    array(
      'name' => 'medium',
      'width' => '240',
      'hight' => '250'
    ),
    array(
      'name' => 'small',
      'width' => '80',
      'hight' => '80'
    ),
  );

  $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);
  // print_r($_FILES);die();

  if (isset($_FILES['image']['name']) and $_FILES['image']['name'] != '') {
    // print_r($_FILES['image']);
    // die();
    //get file name
    $file['name'] = addslashes($_FILES['image']["name"]);
    // get file type
    $file['type'] = $_FILES['image']['type'];
    // get filesize in KB
    $file['size'] = $_FILES['image']['size'] / 1024;
    // get file tmp path
    $file['tmp'] = $_FILES['image']['tmp_name'];
    //get file ext [to get max uploades size]
    $file['ext'] = $upload->GetExt($_FILES['image']["name"]);
    //check if guest have selected file or not
    if ($file['name'] != '') {
      // Start Uploading File
      $upfile = $upload->Upload_File($file, $maxsize);
      //if uploagetCategoryByParentIDding successfully
      // echo $upfile;die();
      if ($upfile) {
        $temp['image'] = $upfile['newname'];
        //   // print_r ($temp[$key]);die();
      } else {
        $error = true;
        $showError[] = $upload->showErrors();
        $top_msg['error'][] = $showError[0][0];
        echo $showError[0][0];
        die();
      }
      // print_r($_FILES['image']);
      // die();
    } else {
      $temp = null;
    }

  }
  

 

  // Update category with appropriate image information
  $result = $categoryObj->editCategory($id,$_POST['langs'], $temp['image'], $sort);

  if ($result) {
    $data['msg'] = 'Row updated successfully.';
    $data['status'] = true;
    $data['data'] = $result;
  } else {
    $data['msg'] = 'Error updating row.';
    $data['status'] = false;
  }
} elseif ($requestMethod == "POST" && isset($_GET["action"]) && $_GET["action"] == "delete") {
  $json = file_get_contents('php://input');
  $data = json_decode($json, true);
  $id = $data['id'];
  // print_r(implode(',', $id));
  $categoryData = $categoryObj->deleteCategory($id);
  $Data     = $categoryData ? $categoryData : '';
  if ($categoryData) {
    
    $data['msg'] = " deleted successfully.";
    $data['status'] = true;
    $data['data'] = $categoryData;
    
  } else {
    $data['msg'] = "Error deleted row.";
    $data['status'] = false;
  }
}
echo json_encode($data);
