<?php

$categoryObj = new Categories();

class Categories
{
  var $mDb;
  var $mConfig;

  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
  }

  function convert_object_to_array($data)
  {
    if (is_object($data)) {
      $data = get_object_vars($data);
    }

    if (is_array($data)) {
      return array_map(__METHOD__, $data);
    } else {
      // echo "test"; die();
      return $data;
    }
  }

  function fetchALL($lang)
  {
    $stmt = "SELECT cl.description, cl.name, cl.lang_code FROM categories c LEFT JOIN `categories_langs` cl ON c.id = cl.category_id";


    $res = $this->mDb->getAll($stmt);
    return $res;
  }

  function addCategory($langs, $image, $sort)
  {
    $categoryLangObj = json_decode($langs);
    $newcategoryLangObj = $this->convert_object_to_array($categoryLangObj);

    $stmt = "INSERT INTO `categories` (`image`, `sort`) VALUES ";
    $stmt .= "('{$image}', '{$sort}')"; 
    $this->mDb->query($stmt);
    

    $last_category_id = $this->mDb->getLastInsertId();
    // echo $last_category_id;
    // die();

    foreach ($newcategoryLangObj as $key => $value) {
      // $value['description'] = strip_tags($value['description']);
      $stmt = "INSERT INTO `categories_langs`(`category_id`, `lang_code`, `name`, `description`) ";
      $stmt .= " VALUES ('{$last_category_id}', '{$value['lang_code']}', '{$value['name']}', '{$value['description']}')";
      // echo $stmt;die();
      $res = $this->mDb->query($stmt);
    }


    $sql = "SELECT * FROM categories where id ='{$last_category_id}'";

    return  $this->mDb->getAll($sql);
  }

  function editCategory($id, $langs, $newImage, $sort)
  {
    $categoryLangObj = json_decode($langs);
    $newcategoryLangObj = $this->convert_object_to_array($categoryLangObj);
    $sql = "SELECT `image` FROM `categories` WHERE `id` = '{$id}'";
    $oldImage = $this->mDb->getOne($sql);

    $stmt = "UPDATE `categories` SET  `image` = '{$newImage}',  `sort` = '{$sort}' WHERE `id` = '{$id}'";
    $this->mDb->query($stmt);

    // Delete the previous image if it exists
    if (!empty($oldImage)) {
      $oldImagePath = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . $oldImage;
      if (file_exists($oldImagePath)) {
        unlink($oldImagePath);
      }
    }
    foreach ($newcategoryLangObj as $key => $value) {
      $value['description'] = str_replace("'", "\'", $value['description']);
      $stmt = "UPDATE `categories_langs` SET";
      $stmt .= " `name`='{$value['name']}', ";
      $stmt .= " `description`='{$value['description']}' ";
      $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `category_id` = '{$id}'";

      $res = $this->mDb->query($stmt);
    }


    // Return the updated category data
    $sql = "SELECT * FROM `categories` WHERE `id` = '{$id}'";
    return $this->mDb->getRow($sql);
  }

  function deleteCategory($id)
  {
    // (1,2,3,4,5,6)
    $category_ids = '(' . implode(',', $id) . ')';
    $sql = "SELECT `image` FROM `categories`";
    $sql .= " WHERE `id` IN " . $category_ids;
    $images = $this->mDb->getAll($sql);
    $sqll = "DELETE FROM `categories_langs` ";
    $sqll .= " WHERE `category_id` IN " . $category_ids;

    $this->mDb->query($sqll);

    $categorysql = "DELETE FROM `categories` ";
    $categorysql .= " WHERE `id` IN " . $category_ids;

    if ($this->mDb->query($categorysql)) {

      if (count($images) > 0) {
        for ($i = 0; $i < count($images); $i++) {
          $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . $images[$i]['image'];
          if (file_exists($old_img)) {
            @unlink($old_img);
          }
        }
      }
      return true;
    } else {
      return false;
    }
  }
}
